var currentURLIndex;
var currentID;
var imageURL = '';
var timerInterval = null;
var refreshRate = 5000;

var URLs = new Array("http://image.weather.com/");                     

function refreshIt() {
   if (!document.images) return;
   document.images[0].src = 'http://image.weather.com' + currentID + Math.random();
   setTimeout('refreshIt()',600000); // refresh every 10 min
                      }

function clicked(currentID)

   {
        if (widget)

        {
            widget.openURL('' + currentID);
        }
    }

function loaded ()
{
    currentURLIndex = 0;
    currentID = 'images/maps/current/curwx_600x405.jpg';
    
    if(window.widget)
    {
        var location = widget.preferenceForKey("location");
        if (location && location.length > 0)
        {
            currentID = location;
        }
    }

    document.images[0].src = URLs[currentURLIndex] + currentID;
    document.images[0].height = 205;
    document.images[0].width = 305;

    var doneButton = document.getElementById('done');
    createGenericButton(doneButton, 'Done', showFront);
}

if (window.widget) {
	widget.onhide = onhide;
	widget.onshow = onshow;
		}
			
function onshow() {
	updateMap();
	if (timerInterval == null) {
		timerInterval = setInterval('updateMap();', refreshRate);
	 }
}

function onhide() {		
    if (timerInterval != null) {
    	clearInterval(timerInterval);
    	timerInterval = null;
	}
}			

function updateMap() {
	document.images[0].src = URLs[currentURLIndex] + currentID + '?' + Math.random();
    return true;
}

function locationchanged(elem)
{	
    var selection = elem.options[elem.selectedIndex].value;
    
    if (selection.length > 0)
    {
	   currentID = selection;
	}
	
	currentURLIndex = 0;
	
	document.images[0].src = URLs[currentURLIndex] + currentID;

	
	if (window.widget)
	{
		widget.setPreferenceForKey(currentID, "location");
	}
}

var lastPos;

function showBack()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
        
    if (window.widget)
        widget.prepareForTransition("ToBack");
                
    front.style.display="none";
    back.style.display="block";
        
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);  
}

function showFront()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
        
    if (window.widget)
        widget.prepareForTransition("ToFront");
                
    back.style.display="none";
    front.style.display="block";
        
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}

var flipShown = false;

var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};

function mousemove (event)
{
    if (!flipShown)
    {
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 50;
                
        animation.duration = 1000;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 50);
        animation.from = animation.now;
        animation.to = 1.0;
        animate();
        flipShown = true;
    }
}

function mouseexit (event)
{
    if (flipShown)
    {
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 0.0;
        animate();
        flipShown = false;
    }
}

function animate()
{
    var T;
    var ease;
    var time = (new Date).getTime();           
        
    T = limit_3(time-animation.starttime, 0, animation.duration);
        
    if (T >= animation.duration)
    {
        clearInterval (animation.timer);
        animation.timer = null;
        animation.now = animation.to;
    }
    else
    {
        ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
        animation.now = computeNextFloat (animation.from, animation.to, ease);
    }
        
    animation.firstElement.style.opacity = animation.now;
}

function limit_3 (a, b, c)
 {
    return a < b ? b : (a > c ? c : a);
 }

function computeNextFloat (from, to, ease)
 {
    return from + (to - from) * ease;
 }
